{$M 2048,0,0}
{*********************************************************}
{                                                         }
{       Borland Pascal 7.0                                }
{        Ctrl ন - ६ 뢥.             }
{                                                         }
{       Copyright (c) 1997 by Alone SoftMaker             }
{                             Andy Petrusenco             }
{                                                         }
{*********************************************************}

program CTRLCLCK;
uses
  Dos;

const
  { ⠭ -  }
  TSRId      = $1234;
  IsPresent  = $1234;
  Unload     = $5678;
  YesPresent = $4321;
  UnloadErr  = $FEFE;
  Unloaded   = $8765;

type
  TInterrupt = procedure (Flags: Word);
    { ࠡ稪 뢠 }

const
  State: (stShowFirst, stShow, stHide, stNothing) = stNothing;
    { ﭨ - 뢠, , 祣 }

var
  SaveScr: array[1..20] of Byte;
    { ࠭ ࠭ }
  H, M, S, S100: Word;
    { ६ }
  Screen: array[1..25, 1..80, (Char, Attr)] of Byte absolute $B800:$0000;
    { ࠭ }
  T: Integer;
  Temp1, Temp2, Temp3, OldInt1C, OldInt09, OldInt12: TInterrupt;
    {  ࠡ稪 }
  R: Registers;
    { ॣ }

  {==[ Int1C ]==============================================}
  { ࠡ稪 Int 1C                                       }
  {=========================================================}
  procedure Int1C(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
    interrupt;
  begin { Int1C }
    case State of
      {  1- ࠧ }
      stShowFirst: begin
        { ࠭ ࠭ }
        Move(Screen, SaveScr, SizeOf(SaveScr));
        State := stShow;
      end;
      {  }
      stShow: begin
        GetTime(H, M, S, S100);
        for T := 1 to 10 do
          Screen[1, T, Attr] := $1F;
        Screen[1, 1, Char] := Ord(' ');
        Screen[1, 2, Char] := H div 10 + Ord('0');
        Screen[1, 3, Char] := H mod 10 + Ord('0');
        Screen[1, 4, Char] := Ord(':');
        Screen[1, 5, Char] := M div 10 + Ord('0');
        Screen[1, 6, Char] := M mod 10 + Ord('0');
        Screen[1, 7, Char] := Ord(':');
        Screen[1, 8, Char] := S div 10 + Ord('0');
        Screen[1, 9, Char] := S mod 10 + Ord('0');
        Screen[1, 10, Char] := Ord(' ');
      end;
      {  }
      stHide: begin
        Move(SaveScr, Screen, SizeOf(SaveScr));
        State := stNothing;
      end;
    end;
    { 맢  ࠡ稪 }
    OldInt1C(Flags);
  end; { Int1C }


  {==[ Int09 ]==============================================}
  { ࠡ稪 int 09h                                      }
  {=========================================================}
  procedure Int09(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
            interrupt;
  begin { Int09 }
    case Port[$60] of
      $1D: if State = stNothing then
        State := stShowFirst;
      $1D or $80: State := stHide;
    end;
    OldInt09(Flags);
  end; { Int09 }


  {==[ Int12 ]==============================================}
  { ࠡ稪 int 12h                                      }
  {=========================================================}
  procedure Int12(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);
            interrupt;
  begin { Int12 }
    { ஢ઠ ࢨ }
    if AX = TSRId then begin
      case BX of
        {   ⢨ }
        IsPresent: BX := YesPresent;
        { 㧪 }
        Unload: begin
          BX := Unloaded; {  OK }
          { ஢ઠ ஢ }
          GetIntVec($09, @Temp1);
          GetIntVec($1C, @Temp2);
          GetIntVec($12, @Temp3);
          if (@Temp1 <> @Int09) or (@Temp2 <> @Int1C) or (@Temp3 <> @Int12)
            then BX := UnloadErr { 訡 }
          else begin
            { ⠭  }
            SetIntVec($09, @OldInt09);
            SetIntVec($1C, @OldInt1C);
            SetIntVec($12, @OldInt12);
            { ᢮  }
            R.ES := Word(Ptr(PrefixSeg, $002C)^);
            R.AH := $49;
            Intr($21, R);
            R.ES := PrefixSeg;
            R.AH := $49;
            Intr($21, R);
          end;
        end;
      end;
      { 室 }
      Exit;
    end;
    OldInt12(Flags);
  end; { Int12 }


begin
  { copyright }
  WriteLn('CtrlClock 1.0 (C) 1997 by Alone SoftMaker');
  { ஢ઠ ࠬ஢ }
  if ParamCount = 1 then begin
    {  }
    if ParamStr(1) = '/?' then begin
      WriteLn('CTRLCLCK[.EXE] [<樨>]');
      WriteLn('  /U  - 㧨 १');
      WriteLn('  /?  - ');
    end else
      { 㧪 }
      if (ParamStr(1) = '/U') or (ParamStr(1) = '/u') then begin
        { ஢ઠ ⢨ }
        R.AX := TSRId;
        R.BX := IsPresent;
        Intr($12, R);
        if R.BX <> YesPresent then
          WriteLn('  㦥.')
        else begin
          { 㧨 }
          R.AX := TSRId;
          R.BX := Unload;
          Intr($12, R);
          if R.BX <> Unloaded then
            WriteLn('訡  㧪 १.')
          else
            WriteLn(' ᯥ譮 㦥.');
        end;
      end else
        WriteLn('訡  ࠬ')
  end else begin
    { 㧪 १ }
    R.AX := TSRId;
    R.BX := IsPresent;
    Intr($12, R);
    if R.BX = YesPresent then
      WriteLn(' 㦥 㦥. H Ctrl  ⨢樨.')
    else begin
      GetIntVec($09, @OldInt09);
      GetIntVec($1C, @OldInt1C);
      GetIntVec($12, @OldInt12);
      SetIntVec($09, @Int09);
      SetIntVec($1C, @Int1C);
      SetIntVec($12, @Int12);
      WriteLn('  ६ 室 㤥ন Ctrl.');
      Keep(0);
    end;
  end;
end.

